﻿/**
 * @class BaseCollection
 */
define([
    'backbone',
    'settings',
    'utils/modelUtil'
], function (Backbone, settings, modelUtil) {
    return Backbone.Collection.extend({

        locationContext: null,

        initialize: function (models, options) {
            Backbone.Collection.prototype.initialize.apply(this, arguments);
            options && options.locationContext && (this.locationContext = options.locationContext);
        },

        url: function () {
            /*
             Возможные формы URL'а:
             1. /api/area/7283784728374234/workspace/782874872834/task
             2. /api/area/7283784728374234/workspace/782874872834/task/873847587345/discussion
             3. /api/task
             */
            var url = settings.restUrlBase;
            if (this.locationContext) {

                _.each(_.sortBy(_.pairs(this.locationContext), modelUtil.urlComponentSorter()), function (pair) {
                    (pair[0] && pair[1]) && (url += pair[0] + '/' + pair[1] + '/');
                });
            }
            var entityType = this.model.prototype.entityType;
            (url[url.length - 1] !== '/') && (url += '/');
            url += entityType;
            return url;
        },

        parse: function (response, options) {
            var responseObj = response.result ? response.result : response;
            return Backbone.Collection.prototype.parse.call(this, responseObj, options);
        }

    });

});
