﻿/**
 * @class BaseModel
 */
define([
    'backbone',
    'settings',
    'utils/modelUtil'
],
    function (Backbone, settings, modelUtil) {
        return Backbone.Model.extend({

            locationContext: null,
            entityType: null,

            initialize: function (models, options) {
                Backbone.Model.prototype.initialize.apply(this, arguments);
                options && options.locationContext && (this.locationContext = options.locationContext);
            },

            urlRoot: function () {
                var url = settings.restUrlBase;
                if (this.locationContext) {
                    _.each(_.sortBy(_.pairs(this.locationContext), modelUtil.urlComponentSorter()), function (pair) {
                        (pair[0] && pair[1]) && (url += pair[0] + '/' + pair[1] + '/');
                    });
                }
                (url[url.length - 1] !== '/') && (url += '/');
                url += this.entityType;
                return url;
            },


            parse: function (response, options) {
                var responseObj = response.result ? response.result : response;
                return Backbone.Model.prototype.parse.call(this, responseObj, options);
            },

            getRefId: function(refAttribute) {
                var ref = this.get(refAttribute);
                if (ref) {
                    return ref.id;
                } else {
                    return undefined;
                }
            }


        });
    }
);

