﻿/**
 * Настройки приложения.
 */
define(['underscore', 'environment'], function (_, environment) {

    var profiles = {
        development: {
            restUrlBase: 'http://localhost:666/api/mobile/1.0/',
            authenticationUrlBase: 'http://localhost:666/api/'
        },
        mobile: {
            restUrlBase: 'https://app.teambridge.ru/api/mobile/1.0/',
            //restUrlBase: 'https://app.devtb.ru/api/mobile/1.0/', 

            authenticationUrlBase: 'https://app.teambridge.ru/api/'
            //authenticationUrlBase: 'https://app.devtb.ru/api/'
        }
    };

    var settings = {

    	clientRouteStart: '#!/',

        development: {
            mockingEnabled: false,
            errorHandlingEnabled: true,
            skipAuthentication: false,
            fakeAuthentication: true
        },

        logging: {
            logLevel: 'debug',
            syncLevel: 'debug'
        },

        ajaxDebugging: true,

        authenticationTimeout: 60000

    };

    var profileName = environment.isMobileBrowser() ? 'mobile' : 'development';
    _.extend(settings, profiles[profileName]);
    settings.profileName = profileName;

    return settings;
});
