﻿define(['underscore', 'moment'], function(_, moment) {

    return {
        get: function(key) {
            return localStorage.getItem(key);
        },

        set: function(key, value) {
            var s;
            if (_.isObject(value)) {
                s = JSON.stringify(value);
            } else {
                s = value;
            }
            var timestamp = moment().unix();
            localStorage.setItem(key, s);
            localStorage.setItem('meta:' + key, JSON.stringify({
                timestamp: timestamp
            }));
        },

        unsetStartingWith: function(keyPrefix) {
            var that = this;
            var keys = _.keys(localStorage);
            _.each(keys, function(key) {
                key.indexOf(keyPrefix) === 0  && key.indexOf('meta:') !== 0 && that.unset(key);
            });
        },

        unsetContaining: function(keySubstring) {
            var that = this;
            var keys = _.keys(localStorage);
            _.each(keys, function(key) {
                key.indexOf(keySubstring) >=0 && key.indexOf('meta:') !== 0 && that.unset(key);
            });
        },

        clearAllAjax: function ()
        {
        	var that = this;
        	var keys = _.keys(localStorage);
        	_.each(keys, function (key)
        	{
        		(key.indexOf('ajax_') == 0 || key.indexOf('meta:') == 0) && that.unset(key);
        	});
        },

        unset: function(key) {
            localStorage.removeItem(key);
            localStorage.removeItem('meta:' + key);
        }
    };

});

