﻿define([
    'underscore',
    'jquery',
    'settings',
    'utils/CachableRefData',
    'pubSub'
], function(
    _,
    $,
    settings,
    CachableRefData,
    pubSub) {

    var allUsersCache = new CachableRefData(settings.restUrlBase + 'user?include=roles');
    allUsersCache.onUpdated = function(data) {
        pubSub.trigger('allUsers:updated');
    }
    pubSub.on('login:success', function () {
        allUsersCache.updateIfExpired();
    });
    allUsersCache.allUserIds = function() {
        var allUsers = this.get();
        return _.map(allUsers, function(user) {
            return user.id;
        });
    };
    return allUsersCache;

});