﻿define([
    'underscore',
    'jquery',
    'settings',
    'utils/CachableRefData',
    'pubSub'
], function(
    _,
    $,
    settings,
    CachableRefData,
    pubSub) {

    var currentUserCache = new CachableRefData(settings.restUrlBase + 'user/current');
    currentUserCache.onUpdated = function(data) {
        pubSub.trigger('profile:updated', data);
    };
    pubSub.on('login:success', function () {
        currentUserCache.updateIfExpired();
    });
    return currentUserCache;

});