﻿define(['underscore', 'jquery'], function(_, $) {

    var popups = [];

    return {
        register: function(popupView) {
            popups.push(popupView);
            this._syncState();
        },

        unregister: function(popupView) {
            popups = _.without(popups, popupView);
            this._syncState();
        },

        _syncState: function() {
            var $body = $(document.body);
            if (this.hasAny()) {
                $body.addClass('ui-hasPopups');
            } else {
                $body.removeClass('ui-hasPopups');
            }
        },

        hasAny: function() {
            return popups.length > 0;
        },

        closeAll: function() {
            _.each(popups, function(popup) {
                popup && popup.close && popup.close();
            });
            popups = [];
        }
    };

});