﻿define(['underscore'], function(_) {

	var supportedEntities = ['task', 'calendarEvent', 'discussion', 'discussionTopic'];//, 'file', 'folder'];

    return {
        isEntitySupported: function(entityType) {
            return _.contains(supportedEntities, entityType);
        },

        modeForEntity: function(entityType) {
            if (!this.isEntitySupported(entityType)) {
                return undefined;
            }
            switch (entityType) {
                case 'task':
                    return 'tasks';
                case 'discussion':
                    return 'discussions';
                case 'discussionTopic':
                    return 'discussions';
                case 'calendarEvent':
                    return 'calendarEvents';
                case 'file':
                    return 'files';
                case 'folder':
                    return 'files';
            }
            return undefined;
        },

        iconForEntityType: function(entityType) {
            if (!this.isEntitySupported(entityType)) {
                return '';
            }
            switch (entityType) {
                case 'task':
                    return 'check';
                case 'calendarEvent':
                    return 'clock-o';
                case 'discussion':
                    return 'comment-o';
                case 'discussionTopic':
                    return 'comment-o';
                case 'file':
                    return 'file-o';
                case 'folder':
                    return 'folder-open';
            }
            return '';
        }
    };
});