﻿define(['underscore'], function(_) {

    // SSH: don't include this module unless you know what you're doing!

    function domElementAsString(element) {
        var s = element.tagName;
        element.id && (s += '#' + element.id);
        _.each(element.classList, function (className) {
            s += '.' + className;
        });
        return s;
    }

    var listeners = [];

    if (EventTarget) {
        var originalAddEventListener = EventTarget.prototype.addEventListener;
        EventTarget.prototype.addEventListener = function(type, listener, useCapture) {
            listeners.push({
                type: type,
                listener: listener,
                useCapture: useCapture,
                target: this
            });
            originalAddEventListener && originalAddEventListener.apply(this, arguments);
        }

        var originalRemoveEventListener = EventTarget.prototype.removeEventListener;
        EventTarget.prototype.removeEventListener = function(type, listener, useCapture) {
            var that = this;
            listeners = _.filter(listeners, function(l) {
                return !(type === l.type && listener === l.listener && that === l.target);
            });
            originalRemoveEventListener && originalRemoveEventListener.apply(this, arguments);
        }
    }

    return {
        listenerInfo: function() {
            return _.map(listeners, function(l) {
                return l.type + ' | ' + domElementAsString(l.target);
            }).join('\n');
        }
    };
});