﻿define(['underscore', 'jquery', 'environment', 'pubSub', 'log', 'utils/cache/allUsersCache', 'settings', 'authentication'], function(_, $, environment, pubSub, log, allUsersCache, settings, authentication) {

    function appRootFolder() {
        var href = location.href;
        //href = 'file:///tmp/one/two/three/app.root/www/index.html#!/something/else';
        if (href.indexOf('file://') === 0) {
            //href = href.slice(7);
            var hashPosition = href.lastIndexOf('#');
            hashPosition = hashPosition === -1 ? href.length : hashPosition;
            var folderSlashPosition = href.lastIndexOf('/', hashPosition);
            href = (folderSlashPosition === -1 ? href : href.slice(0, folderSlashPosition));
            return href.slice(0, href.lastIndexOf('www'));
        } else {
            return '';
        }
    }

    // TODO: this module functions:
    // TODO photo initial loading
    // TODO photo reloading
    // TODO local file system management

    // TODO function: download a file by URL to a given section
    // TODO temp section - only for one time images

    // we can split local file system to sections (roots): photos, attachments etc.
    // for some sections we will have custom management lifecycles
    //----------------

    //alert('fileManager: begin');
    //try {



    window.requestFileSystem  = window.requestFileSystem || window.webkitRequestFileSystem;
    var useFileTransfers = environment.isMobileBrowser() && (window.FileTransfer) && (window.requestFileSystem);
    var usePhotos = useFileTransfers;
    var fileTransfer = useFileTransfers ? new FileTransfer() : undefined;

    var photos = {};
    var noPhotoUrl = 'images/unknownUser.jpeg';
    var appDataDirectoryUrl;
    var photosDirectoryUrl;
    //if (environment.isIOS()) {
    //    /*-*///alert('It is iOS');
    //    /*-*///alert('Location = ' + JSON.stringify(location));
    //    var rootFolder = appRootFolder();
    //    /*-*///alert('AppRootFolder = ' + rootFolder);
    //    appDataDirectoryUrl = rootFolder + 'Library/NoCloud/';
    //    photosDirectoryUrl = appDataDirectoryUrl + 'photos/';
    //    /*-*///alert('appDataDirectoryUrl = ' + appDataDirectoryUrl + ', photosDirectoryUrl = ' + photosDirectoryUrl);
    //    /*window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function(fileSystem) {
    //        try {


    //        appDataDirectoryUrl = fileSystem.root.fullPath + '/Library/NoCloud/';
    //        photosDirectoryUrl = appDataDirectoryUrl + 'photos/';
    //        alert('appDataDirectoryUrl = ' + appDataDirectoryUrl + ', photosDirectoryUrl = ' + photosDirectoryUrl);
    //        } catch (error) {
    //            alert('Caught error in requestFileSystem success callback: ' + JSON.stringify(error));
    //        }
    //    }, function(err) {
    //        alert('Error: ' + JSON.stringify(err));
    //    });*/
    //    /*-*///alert('fileManager: after requestFileSystem');

    //} else {
        appDataDirectoryUrl = (window.cordova && window.cordova.file) ? window.cordova.file.dataDirectory : '';
        photosDirectoryUrl = appDataDirectoryUrl + 'photos/';
        //cordova.file.dataDirectory - Persistent and private data storage within the application's sandbox using internal memory
    //}

    /*log.debug('fileManager initial state dump', {
        values: {
            appDataDirectoryUrl: appDataDirectoryUrl,
            photosDirectoryUrl: photosDirectoryUrl,
            requestFileSystem: _.isFunction(window.requestFileSystem),
            useFileTransfers: useFileTransfers,
            usePhotos: usePhotos
        }
    });*/

    var fileManager = {

        uploadFile: function(localUrl, options) {
            var target = options.target;
            var areaId = target.areaId;
            var workspaceId = target.workspaceId;
            var folderId = target.folderId;
            var remoteUrl = settings.restUrlBase + 'area/' + areaId + '/workspace/' + workspaceId +
                (folderId ? '/folder/' + folderId : '') + '/file';
            this.upload(localUrl, remoteUrl, options);
        },

        uploadAttachment: function(localUrl, options) {
            var target = options.target;
            var entityType = target.entityType;
            var entityId = target.entityId;
            var remoteUrl = settings.restUrlBase + entityType + '/' + entityId + '/attachment';
            this.upload(localUrl, remoteUrl, options);
        },
        upload: function(localUrl, remoteUrl, options) {
            log.debug('upload: uploading a file', {
                remoteUrl: remoteUrl,
                localUrl: localUrl
            });
            if (!useFileTransfers) {
                log.warn('File transfers not supported. Cannot download file: ' + remoteUrl);
                return;
            }
            var headers = {};
            authentication.addAuthTokenToHeaders(headers);
            /*-*///remoteUrl = 'http://77.240.12.13:9989';
            fileTransfer.upload(localUrl, remoteUrl, function() {
                // TODO remove
                //alert('uploaded');
                log.debug('File successfully uploaded.', {
                    sourceURL: localUrl,
                    targetURL: remoteUrl
                });
                options.success && options.success();
            }, function(error) {
                //alert('Upload error: ' + JSON.stringify(error));
                log.debug('File uploading failed.', {
                    sourceURL: localUrl,
                    targetURL: remoteUrl,
                    errorCode: error.code,
                    httpStatus: error.http_status,
                    body: error.body
                });
                options.error && options.error(error);
            }, {
                headers: headers,
                fileName: options.fileName
            });
        },
        download: function(remoteUrl, localUrl, options) {
            log.debug('download: downloading a file', {
                remoteUrl: remoteUrl,
                localUrl: localUrl
            });
            if (!useFileTransfers) {
                log.warn('File transfers not supported. Cannot download file: ' + remoteUrl);
                return;
            }
            fileTransfer.download(remoteUrl, localUrl, function() {
                log.debug('File successfully downloaded.', {
                    sourceURL: remoteUrl,
                    targetURL: localUrl
                });
                //photos[id] = true;
                options.success && options.success();// TODO what args to pass? generated file name?
            }, function(error) {
                log.debug('File downloading failed.', {
                    sourceURL: remoteUrl,
                    targetURL: localUrl,
                    errorCode: error.code,
                    httpStatus: error.http_status,
                    body: error.body
                });
                options.error && options.error(error);
            });
        },
        loadPhotos: function() {
            log.debug('loadPhotos: begin');
            if (!usePhotos) {
                log.warn('loadPhotos: not using photos');
                return;
            }
            if (!allUsersCache) {
                log.warn('loadPhotos: no user cache');
                // TODO implement returning to this action later
                return;
            }
            var photoIdsToLoad = allUsersCache.allUserIds();
            _.each(photoIdsToLoad, function(id) {
                var remoteUrl = settings.restUrlBase + 'user/' + id + '/photo?size=small';
                var localFileName = id + '-small';
                var localPhotoUrl = photosDirectoryUrl + localFileName;
                window.resolveLocalFileSystemURL(localPhotoUrl, function() {
                    // photo file already exists
                    photos[id] = true;
                }, function() {
                    // cannot find photo file - download it
                    fileManager.download(remoteUrl, localPhotoUrl, {
                        success: function() {
                            photos[id] = true;
                        }
                    });
                });

            });
        },

        getPhotoUrl: function(userId) {
            if (usePhotos && userId && photos[userId]) {
                return photosDirectoryUrl + userId + '-small';
            }
            return noPhotoUrl;
        }
    };

    function initiatePhotoLoading() {
        log.debug('initiatePhotoLoading: begin');
        if (!usePhotos) {
        	log.debug('initiatePhotoLoading: not using photos');
            return;
        }
        window.resolveLocalFileSystemURL(appDataDirectoryUrl, function(appDataDirectoryEntry) {
            // TODO extract to ensureSectionExists?
            appDataDirectoryEntry.getDirectory('photos', {create: true, exclusive: false}, function() {
                fileManager.loadPhotos();
            }, function(error) {
            	log.error('Cannot get photos directory', {
                    errorCode: error.code
            	});
            	log.sync();
            });
        }, function(error) {
            /*-*///alert('window.resolveLocalFileSystemURL appDataDirectoryUrl - oblomingo');
        	log.error('Cannot resolve application data directory', {
                errorCode: error.code
        	});
        	log.sync();
        });
    }

    var initiatePhotoLoadingThrottled = _.throttle(initiatePhotoLoading, 2000);

    pubSub.on('allUsers:updated', function(data) {
        initiatePhotoLoadingThrottled();
    });

    return fileManager;
    /*} catch (err) {
        alert(err);
    }*/


});