﻿define(['underscore', 'jquery', 'pubSub', 'utils/ui', 'mprogress'], function (_, $, pubSub, ui, mprogress)
{
	//var _eventsCounter = 0;
	var listener = function (e)
	{
		e.stopImmediatePropagation();
		e.preventDefault();
		return false;
	};

	var cleaner = function ()
	{
		ui.popup.removeObstacle();
		document.removeEventListener('touchstart', listener, true);
		document.removeEventListener('touchend', listener, true);
		document.removeEventListener('click', listener, true);
	};

	$(document).on('ajaxStart', function ()
	{
		window._ajaxInProgress = true;
		//progressStart();
		ui.popup.addObstacle();

		document.addEventListener('touchstart', listener, true);
		document.addEventListener('touchend', listener, true);
		document.addEventListener('click', listener, true);

		pubSub.trigger('loader:start');
	});

	$(document).on('ajaxStop', function ()
	{
		window._ajaxInProgress = false;
		pubSub.trigger('loader:stop');

		//checker();
		setTimeout(cleaner, 200);
	});

	pubSub.on('update:error', cleaner);
	pubSub.on('error:unhandled', cleaner);
	pubSub.on('error:apiCall', cleaner);
	pubSub.on('error:unauthorizedApiCall', cleaner);

	var intObj = {
		template: 3,
		parent: '#toolProgressBar' // this option will insert bar HTML into this parent Element 
	};
	var indeterminateProgress = new mprogress(intObj);

	var progressStart = function ()
	{
		indeterminateProgress.start();
	};

	var progressStop = function ()
	{
		ui.helpers.requestAnimationFrame(function ()
		{
			indeterminateProgress.end();
		});
	};

	pubSub.on('update:error', progressStop);

	pubSub.on('tool:progress', progressStart);
	pubSub.on('tool:stopProgress', progressStop);

	pubSub.on('error:unhandled', progressStop);
	pubSub.on('error:apiCall', progressStop);
	pubSub.on('error:unauthorizedApiCall', progressStop);


	var intObjEntity = {
		template: 3,
		parent: '#entityProgressBar' // this option will insert bar HTML into this parent Element 
	};
	var indeterminateEntityProgress = new mprogress(intObjEntity);

	var progressEntityStart = function ()
	{
		//if (document.body.className.indexOf('ui-layout-tablet') != -1)
		indeterminateEntityProgress.start();
	};

	var progressEntityStop = function ()
	{
		ui.helpers.requestAnimationFrame(function ()
		{
			indeterminateEntityProgress.end();
		});
	};

	pubSub.on('update:error', progressEntityStop);

	pubSub.on('entity:progress', progressEntityStart);
	pubSub.on('entity:stopProgress', progressEntityStop);

	pubSub.on('error:unhandled', progressEntityStop);
	pubSub.on('error:apiCall', progressEntityStop);
	pubSub.on('error:unauthorizedApiCall', progressEntityStop);

	/*var loaderTimeout = 200;

	function blockKeyboard(evt) {
		return false;
	}

	var $document = $(document);
	var $body = $(document.body);
	var $loader = $('#loader');
	var showingLoader = false;

	function showLoader() {

		if ($body.children('.ui-page').length === 0) {
			return;
		}

		showingLoader = true;
		//animateToRight();
		$loader.addClass('ui-visibleLoader');
		//console.log('ui-visibleLoader added');


	}

	function hideLoader() {
		showingLoader = false;
		$loader.css({
			left: '-1em'
		});
		$loader.removeClass('ui-visibleLoader');
		//console.log('ui-visibleLoader removed');
	}

	pubSub.on('loader:hide', function() {
		hideLoader();
	});


	var timeoutHandle;

	$(document).on('ajaxStart', function () {
		//$document.on('keydown', blockKeyboard);
		timeoutHandle = setTimeout(function () {
			showLoader();
		}, loaderTimeout);
	});

	$(document).on('ajaxStop', function () {
		//$document.off('keydown', blockKeyboard);
		clearTimeout(timeoutHandle);
		hideLoader();
	});*/
});