﻿define(['underscore', 'jquery', 'utils/ui', 'utils/uiManager', 'urlBuilder'], function (_, $, ui, uiManager, urlBuilder)
{

	var allEntities = [
        {
        	value: 'task',
        	caption: 'Задача',
        	icon: 'check'
        },
        {
        	value: 'calendarEvent',
        	caption: 'Событие',
        	icon: 'clock-o'
        },
        {
        	value: 'discussionTopic',
        	caption: 'Обсуждение',
        	icon: 'comments'
        }
	];


	return {
		showEntityCreationMenu: function (router, entityTypes, locationContext, options)
		{
			locationContext = locationContext || {};
			var entities;
			if (_.isEmpty(entityTypes))
			{
				entities = _.clone(allEntities);
			}
			else
			{
				entities = _.filter(allEntities, function (entityDef)
				{
					return _.contains(entityTypes, entityDef.value);
				});
			}

			ui.popup.list({
				items: entities,
				classes: 'ui-popup-list ui-popup-list-up',
				onSelected: function (value, item)
				{
					//var url;
					var entityType;
					switch (value)
					{
						case 'task':
							entityType = 'task';
							break;
						case 'calendarEvent':
							entityType = 'calendarEvent';
							break;
						case 'discussionTopic':
							entityType = 'discussion';
							break;
					}
					if (entityType)
					{
						if (uiManager.isTabletMode())
						{
							var args = {
								entityId: 'new',
								areaId: !_.isEmpty(locationContext) ? locationContext.areaId : undefined,
								workspaceId: !_.isEmpty(locationContext) ? locationContext.workspaceId : undefined,
								router: router
							};
							if (options && options.date)
								args.date = options.date;

							uiManager.openCard(entityType, args);
						}
						else
						{
							var url = urlBuilder[entityType]('new', 'edit', locationContext);
							if (options && options.date)
								url += '/date/' + options.date;
							router.navigate(url, { trigger: true, replace: false });
						}
					}

				}
			});
		}
	};

});