﻿define(['underscore'], function (_)
{
	var _ignoreOneRememberCall = false;
	var _restoreAllowed = false;
	var _stack = new Object(null);

	return {
		remember: function (view)
		{
			if (!view || !view.el || !view.cardEntityType)
				return;

			var $container = view.$('.js-content');
			if ($container.length > 0)
			{
				var key = view.cardEntityType + ':' + view.el.className;
				_stack[key] = $container[0].scrollTop;
			}
		},
		onRemove: function (className)
		{
			if (!_.isUndefined(_stack[className]))
				delete _stack[className];
		},

		clear: function ()
		{
			_stack = new Object(null);
		},

		backNavigationDetected: function ()
		{
			_ignoreOneRememberCall = true;
			_restoreAllowed = true;
		},

		tryRestore: function (view)
		{
			//if (view && view.el && view.el.className == 'ui-card ui-entityCard')
			//	document.body.scrollTop = 0;

			if (!view || !view.el || !view.cardEntityType)
				return;

			var $container = view.$('.js-content');
			if ($container.length > 0)
			{
				var key = view.cardEntityType + ':' + view.el.className;

				if (!_.isUndefined(_stack[key]))
					$container[0].scrollTop = _stack[key];
				else
					$container[0].scrollTop = 0;
			}
		}
	}
});