﻿define(['underscore', 'jquery', 'environment', 'utils/ui', 'utils/formatter'], function(_, $, environment, ui, formatter) {

    return {
        form: {
            dateTimePicker: function($hiddens, options) {
                //alert('dateTimePicker: begin');
                if (environment.isIOS() && window.datePicker) {
                    //alert('dateTimePicker: iOS detected');
                    options = options || {};
                    return ui.form.picker($hiddens, _.defaults(options, {
                        classes: 'ui-picker-date',
                        onClick: function ($root, options, $hidden) {
                            // use native DTP
                            //alert('dateTimePicker: onClick');
                            var selectedDateTime = $hidden.val();
                            var opts = {
                                date: selectedDateTime ? moment(selectedDateTime).toDate() : new Date(),
                                mode: 'datetime',
                                doneButtonLabel: 'Выбрать',
                                cancelButtonLabel: 'Отменить'
                            };

                            window.datePicker && datePicker.show(opts, function(dateAsObject) {
                                //alert('dateTimePicker: selected');
                                //alert("date result: " + date + ' | ' + date.toString() + ' | ' + (typeof (date)));
                                //var dateTimeAsString = moment(date).utc().format(formatter.serviceDateTimeFormat);
                                //$hidden.val(dateTimeAsString);
                                var selectedMoment = moment(dateAsObject);
                                var caption = selectedMoment.format(formatter.humanDateTimeFormat);
                                var selectedDateTime = moment(selectedMoment).utc().format(formatter.serviceDateTimeFormat);

                                $root.empty().append(ui.helpers.pickerIcon(options, selectedDateTime)).append(ui.helpers.$pickerValueSpan({value: selectedDateTime}).text(caption));
                                $hidden.val(selectedDateTime).trigger('change');
                                options.onSelected && options.onSelected.call(ui, selectedDateTime);
                            });
                            //alert('dateTimePicker: shown...');
                        },
                        onRefresh: function ($root, options, $hidden) {
                            //alert('dateTimePicker: onRefresh - begin');
                            var strValue = $hidden.val();
                            var caption;
                            if (_.isEmpty(strValue)) {
                                caption = options.emptyCaption || ui.helpers.defaultEmptyCaption;
                            } else {
                                var dateTimeMoment = moment(strValue);
                                caption = formatter.serviceDateTimeToHuman(dateTimeMoment);
                            }
                            $root.empty().append(ui.helpers.pickerIcon(options, strValue)).append(ui.helpers.$pickerValueSpan({value: strValue}).text(caption));
                            //alert('dateTimePicker: onRefresh - end');
                        }
                    }));


                } else {
                    // Default branch for systems that don't support beautiful DTPs
                    return ui.form.dateTimePicker($hiddens, options);
                }
            }
        }

    };

});