﻿
//
// Парсинг клиентской части url 
//
// Пример: url.location().parse().get('area');
//
define(['underscore', 'settings'], function (_, settings)
{
	return {
		url: null,
		parsedUrl: null,

		location: function ()
		{
			this.parsedUrl = null;
			this.url = (document.location.hash || '');
			return this;
		},

		parse: function (url)
		{
			url = url || this.url;

			this.url = null;
			this.parsedUrl = null;

			var startIdx = url.indexOf(settings.clientRouteStart);
			if (startIdx >= 0 && startIdx + settings.clientRouteStart.length < url.length)
			{
				this.parsedUrl = url.substring(startIdx + settings.clientRouteStart.length).split('/');
				this.parsedUrl.unshift('route');
			}
			else
			{
				startIdx = url.indexOf(settings.restUrlBase);
				if (startIdx >= 0 && startIdx + settings.restUrlBase.length < url.length)
					this.parsedUrl = url.substring(startIdx + settings.restUrlBase.length).split('/');
			}
			return this;
		},

		get: function (parameterName)
		{
			if (this.parsedUrl == null)
				return null;

			for (var i = 0; i < this.parsedUrl.length; ++i)
			{
				if (this.parsedUrl[i] == parameterName && i + 1 < this.parsedUrl.length)
				{
					return this.parsedUrl[i + 1];
				}
			}
			return null;
		},

		asObject: function ()
		{
			if (this.parsedUrl == null)
				return null;

			var obj = {};
			for (var i = 0; i < this.parsedUrl.length; i += 2)
			{
				var i2 = i + 1;
				obj[this.parsedUrl[i]] = i2 < this.parsedUrl.length ? this._escapeParam(this.parsedUrl[i2]) : true;
			}
			return obj;
		},


		_escapeParam: function (param)
		{
			param = decodeURIComponent(param);
			return param.replace('<', '&lt;').replace('>', '&gt;').replace('&', '&amp;');
		},
	}
});