﻿define(['underscore', 'jquery'], function(_, $) {

    return {

        formatError: function(error) {
            if (!error) {
                return '';
            }
            if (_.isString(error)) {
                return error;
            } else {
                // TODO implement this case
                return error.toString();
            }
        },

        parseValidationResponse: function(view, response, customValidationHandlers) {
            var that = this;
            view.$('.js-error').remove();
            customValidationHandlers = customValidationHandlers || {};
            _.each(response.result, function(error, fieldName) {
                if (customValidationHandlers[fieldName]) {
                    var validationHandler = customValidationHandlers[fieldName];
                    validationHandler.call(view, error, fieldName, response);
                } else {
                    var $field = view.$('[bound-to="' + fieldName + '"]');
                    if ($field.length > 0) {
                        var validatedControlMarker = $field.attr('validated-control');
                        if (validatedControlMarker) {
                            $field = $field.next('.js-validated-control-' + validatedControlMarker);
                        }
                        $field.after($('<span></span>').addClass('js-error tb-error').html(that.formatError(error)));
                    }
                }
            });
        }
    }

});