﻿/**
 * @class BaseCardView
 */
define(['underscore', 'jquery', 'views/BaseView', 'utils/uiManager', 'text!views/BaseCardView.html'], function(_, $, BaseView, uiManager, template) {

    return BaseView.extend({

        template: template,

        headerTemplate: null,
        contentTemplate: null,

        initialize: function() {
            BaseView.prototype.initialize.apply(this, arguments);
            this.$el.addClass('ui-card');
            this.listenTo(this.pubSub, 'update:success', this.onUpdateSuccess);
        },

        render: function ()
        {
            BaseView.prototype.render.apply(this, arguments);
            this.renderLowerToolbar();
        },

        renderLowerToolbar: function() {
            if (this.lowerToolbar) {
                this.lowerToolbar.remove();
            }
            this.$('.js-lowerToolbar').remove();
            if (!this.lowerToolbarClass) {
                return;
            }
            this.lowerToolbar = new this.lowerToolbarClass({
                parentView: this
            });
            this.lowerToolbar.render();
            this.$el.append(this.lowerToolbar.$el);
        },

        onRefreshRequested: function ()
        {
        	this.pubSub.trigger('entity:progress');
            this.update({
                forceUpdate: true
            });
        },
        onUpdateSuccess: function (cid)
        {
        	if (cid === this.cid)
        	{
        		this.pubSub.trigger('entity:stopProgress');
        	}
        },
    });

});