﻿/**
 * @class BaseViewerView
 */
define([
    'underscore',
    'jquery',
    'backbone',
    'views/BasePageView',
    'text!views/BaseViewerView_header.html',
    'settings',
    'srv'
], function (_, $, Backbone, BasePageView, headerTemplate, settings, srv) {
    return BasePageView.extend({

        headerTemplate: headerTemplate,

        editingAllowed: true,

        model: null,

        events: {
            'click .js-back': 'onBackClicked',
            'click .js-edit': 'onEditClicked'
        },

        initialize: function (options) {
            BasePageView.prototype.initialize.apply(this, arguments);
        },

        createModel: function () {
            // override in subclass
            return new Backbone.Model();
        },

        fetchUrl: null,

        updateData: function (updateOptions) {
            var that = this;
            this.model = this.createModel();
            this.model.id = this.options.entityId;
            var fetchOptions = {
                model: this.model,
                success: function () {
                    that.onDataUpdated();
                }
            };
            this.fetchUrl && (_.isFunction(this.fetchUrl) ? fetchOptions.url = this.fetchUrl() : fetchOptions.url = this.fetchUrl);
            fetchOptions = _.defaults(fetchOptions, updateOptions);
            //this.model.fetch(fetchOptions);
            srv.fetch(fetchOptions);
        },

        onBackClicked: function(evt) {
            this.router.navigateBack();
            evt.preventDefault();
        },

        onEditClicked: function (evt) {
            this.edit();
            evt.preventDefault();
        },

        edit: function () {
            var url = this.editorUrl();
            url && this.router.navigate(url, {trigger: true, replace: false});
        },

        editorUrl: function() {
            return undefined;
        }

    });
});