﻿/**
 * @class ActivitiesFiltersPopupView
 */
define([
    'underscore',
    'jquery',
    'views/common/BaseFilterPopupView',
    'text!views/activities/ActivitiesFiltersPopupView.html',
    'models/activities/ActivitiesFilterModel'
], function(
    _,
    $,
    BaseFilterPopupView,
    template,
    ActivitiesFilterModel
    ) {

    return BaseFilterPopupView.extend({

        template: template,

        filterStorageKey: '__ActivitiesFilter',

        filterModelClass: ActivitiesFilterModel,

        initialize: function(options) {
            BaseFilterPopupView.prototype.initialize.apply(this, arguments);
        },

        _renderFilters: function() {
            var that = this;

            this.ui.form.select(this.$('.js-entityType'), {
                items: [
                    { value: '', caption: 'любой тип сущности'},
                    { value: 'task', caption: 'задачи'},
                    { value: 'calendarEvent', caption: 'события'},
                    { value: 'discussionTopic', caption: 'обсуждения'},
                    { value: 'file', caption: 'файлы'},
                    { value: 'workspace', caption: 'проекты'},
                    { value: 'area', caption: 'порталы'}
                ],
                emptyCaption: 'любой тип сущности',
                onSelected: function() {
                }
            });

            var users = [
                { value: '', caption: 'любой автор изменений'},
                { value: 'me', caption: 'мои изменения'}
            ];
            _.each(this.options.parentView.refData.allUsers, function(user) {
                if (user && user.id !== that.options.parentView.refData.currentUser.id) {
                    users.push({
                        value: user.id,
                        caption: user.name
                    });
                }
            });

            this.ui.form.select(this.$('.js-initiator'), {
                items: users,
                emptyCaption: 'любой автор изменений',
                onSelected: function() {
                }
            });

            this.ui.form.select(this.$('.js-operationType'), {
                items: [
                    { value: '', caption: 'любая операция'},
                    { value: 'create', caption: 'создание'},
                    { value: 'update', caption: 'изменение'},
                    { value: 'delete', caption: 'удаление'}
                ],
                emptyCaption: 'любая операция',
                onSelected: function() {
                }
            });


        }

    });

});