﻿/**
 * @class CalendarEventView
 */
define([
    'underscore',
    'jquery',
    'backbone',
    'views/common/BasePlanItemView',
    'text!views/calendar/CalendarEventView_data.html',
    'models/calendar/CalendarEventModel'
], function (
    _,
    $,
    Backbone,
    BasePlanItemView,
    dataTemplate,
    CalendarEventModel
    ) {
    return BasePlanItemView.extend({

        dataTemplate: dataTemplate,

        headerText: 'Событие',

        createModel: function() {
            return new CalendarEventModel();
        },

        editorUrl: function() {
            if (this.model.has('areaRef') && this.model.has('workspaceRef')) {
                return '#!/calendarEvents/area/' + this.model.get('areaRef').id + '/workspace/' + this.model.get('workspaceRef').id + '/edit/' + this.model.get('id');
            } else {
                return '#!/calendarEvents/edit/' + this.model.get('id');
            }
        }

    });
});