﻿/**
 * @class CalendarFiltersPopupView
 */
define([
    'underscore',
    'jquery',
    'views/common/BaseFilterPopupView',
    'text!views/calendar/CalendarFiltersPopupView.html',
    'models/calendar/CalendarFilterModel'
], function(
    _,
    $,
    BaseFilterPopupView,
    template,
    CalendarFilterModel
    ) {

    return BaseFilterPopupView.extend({

        template: template,

        filterStorageKey: '__CalendarFilter',

        filterModelClass: CalendarFilterModel,

        initialize: function(options) {
            BaseFilterPopupView.prototype.initialize.apply(this, arguments);
        },

        _renderFilters: function() {
            var that = this;

            this.ui.form.select(this.$('.js-dataType'), {
                items: [
                    { value: '', caption: 'любой тип'},
                    { value: 'task', caption: 'только задачи'},
                    { value: 'calendarEvent', caption: 'только события'}
                ],
                emptyCaption: 'любой тип',
                onSelected: function() {
                }
            });

            var users = [
                { value: '', caption: 'любой участник/ответственный'},
                { value: 'me', caption: 'я - участник или ответственный'},
                { value: 'unassigned', caption: 'нет участников/ответственных'}
            ];
            _.each(this.options.parentView.refData.allUsers, function(user) {
                if (user && user.id !== that.options.parentView.refData.currentUser.id) {
                    users.push({
                        value: user.id,
                        caption: user.name
                    });
                }
            });

            this.ui.form.select(this.$('.js-assigneeOrMember'), {
                items: users,
                emptyCaption: 'любой ответственный/участник',
                onSelected: function() {
                }
            });


        }

    });

});