﻿define(['underscore', 'jquery', 'backbone'], function(_, $, Backbone) {

    return {
        /**
         * It can be 'reduced' and 'all'
         */
        displayMode: 'reduced',

        reducedModeItemCount: 5,

        showAll: function() {
            this.displayMode = 'all';
            this.render();
            this.pubSub.trigger('card:resized');
        },

        _displayingIndices: function() {
            var indexFrom;
            var indexToExclusive;
            var reduced;
            if (this.displayMode === 'reduced') {
                if (this.collection.length > this.reducedModeItemCount) {
                    indexFrom = this.collection.length - this.reducedModeItemCount;
                    indexToExclusive = this.collection.length;
                    reduced = true;
                } else {
                    indexFrom = 0;
                    indexToExclusive = this.collection.length;
                    reduced = false;
                }
            } else {
                indexFrom = 0;
                indexToExclusive = this.collection.length;
                reduced = false;
            }
            return {
                indexFrom: indexFrom,
                indexToExclusive: indexToExclusive,
                reduced: reduced
            };
        },

        onShowAll: function(evt) {
            evt.preventDefault();
            this.showAll();
        }

    };

});