﻿define([
    'underscore',
    'jquery',
    'views/BasePageView',
    'text!views/common/CommentComposerPageView_header.html',
    'text!views/common/CommentComposerPageView_content.html',
    'models/common/CommentModel',
    'srv',
    'settings'
], function(
    _,
    $,
    BasePageView,
    headerTemplate,
    contentTemplate,
    CommentModel,
    srv,
    settings
    ) {

    return BasePageView.extend({

        headerTemplate: headerTemplate,
        contentTemplate: contentTemplate,

        shouldScrollToBottomWhenDone: true,

        events: {
            'click .js-close': 'onClose',
            'click .js-post': 'onPost',
            'click textarea': 'onTextAreaClicked'
        },

        initialize: function(options) {
            BasePageView.prototype.initialize.apply(this, arguments);
        },

        render: function() {
            var that = this;
            this.$el.addClass('tb-commentComposer');
            BasePageView.prototype.render.apply(this, arguments);

            setTimeout(function() {
                that.fitElements();
                window.scroll(0, 0);
                that.$('textarea').click();
            }, 100);


        },

        onTextAreaClicked: function(evt) {
            $(evt.currentTarget).focus();
        },

        onClose: function(evt) {
            this.closePage();
            evt.preventDefault();
            //this.scrollToBottomWhenDoneIfNeeded();
        },

        onPost: function(evt) {
            var that = this;
            var comment = new CommentModel();
            var body = this.$('textarea').val();

            comment.set({
                body: body,
                parentEntityID: this.options.commentTarget.entityId,
                parentEntityType: this.options.commentTarget.entityType,
                permissions: {}
            });

            srv.save({
                model: comment,
                url: settings.restUrlBase + 'comment',
                success: function() {
                    that.$('textarea').val('');
                    srv.clearCache(that.options.commentTarget.entityType);
                    that.options.onPosted && that.options.onPosted.call(that, comment);
                    that.closePage();
                    that.scrollToBottomWhenDoneIfNeeded();
                }
            });

            evt.preventDefault();
        },

        scrollToBottomWhenDoneIfNeeded: function() {
            return;
            if (this.shouldScrollToBottomWhenDone) {
                this.ui.scrollToBottom(true);
            }
        }






    });

});