﻿/**
 * @class EmbeddableCommentsView
 */
define([
    'underscore',
    'jquery',
    'views/BaseView',
    'text!views/common/EmbeddableCommentsView.html',
    'settings',
    'views/collectionReductionSupport',
    'views/common/EmbeddableAttachmentListView'
], function (_, $, BaseView, template, settings, collectionReductionSupport, EmbeddableAttachmentListView) {
    return BaseView.extend({

        template: template,

        collection: null,

        autoUpdate: false,

        events: {
            'click .js-showAll': 'onShowAll',
            'click .tb-link': 'onLinkClicked'
        },

        initialize: function (options) {
            this.include(collectionReductionSupport);
            BaseView.prototype.initialize.apply(this, arguments);
            this.collection = options.collection;
        },

        render: function() {
            BaseView.prototype.render.apply(this, arguments);
            this._renderAttachments();
        },

        _renderAttachments: function() {
            var that = this;
            this.$('.js-attachmentsBlock').each(function() {
                var $container = $(this);
                var commentIndex = $container.attr('data-comment-index');
                var comment = that.collection.at(commentIndex);
                var attachments = comment.get('attachments');
                if (!_.isEmpty(attachments)) {
                    var attachmentListView = that.createChildView(EmbeddableAttachmentListView, {
                        attachments: attachments,
                        collection: null,
                        borderBottom: false
                    });
                    attachmentListView.render();
                    attachmentListView.$el.appendTo($container);
                }
            });

        },

        onLinkClicked: function(evt) {
            evt.preventDefault();
            var href = $(evt.currentTarget).attr('href');
            window.open(href, '_system');
        }

    });
});