﻿/**
 * @class UserListViewPage
 */
define(['underscore', 'jquery', 'views/common/ListViewPage'], function(_, $, ListViewPage) {
    return ListViewPage.extend({

        defaultIcon: 'suitcase',
        usePhotos: true,

        headerText: 'Выберите пользователя',

        initialize: function(options) {
            this.initFieldFromOption('headerText');
            ListViewPage.prototype.initialize.apply(this, arguments);
        },

        usersToItems: function(users, emptyCaption) {
            emptyCaption = emptyCaption || 'Никому не назначена';
            var allItems = [{
                id: '',
                caption: emptyCaption,
                classes: 'tb-nobody ui-empty'
            }];

            users = _.filter(users, function (item) { return item.blocked === false; });

            var userItems = _.map(users, function (user)
            {
            	return {
            		id: user.id,
            		caption: user.name
            	};
            });
            allItems = allItems.concat(userItems);
            return allItems;
        }

        /*decorateItem: function($li, item) {

        }*/
    });
});