﻿/**
 * @class WorkspaceListViewPage
 */
define(['underscore', 'jquery', 'views/common/ListViewPage'], function(_, $, ListViewPage) {

    return ListViewPage.extend({

        defaultIcon: 'suitcase',

        headerText: 'Выберите проект',

        initialize: function(options) {
            //options.items = options.items || this._structureToItems(options.structure);
            ListViewPage.prototype.initialize.apply(this, arguments);
        },

        structureToItems: function(structure, options) {
            options = options || {};
            var items = [];

            // WARNING: the same code is in the Sidebar_data.html
            var sortedAreas = _.sortBy(structure.areas, function(area) {
                switch (area.type) {
                    case 'my':
                        return 8;
                    case 'private':
                        return 9;
                    default:
                        return 1;

                }
            });
            _.each(sortedAreas, function(area) {
                if (area.type !== 'private') {
                    items.push({
                        id: area.id,
                        caption: area.title,
                        type: 'area',
                        selectable: false,
                        icon: '-'
                    });
                }
                _.each(area.workspaces, function(workspace) {
                    if (options.excludeMyRoot && (area.type === 'my' && workspace.isRoot)) {
                        return;
                    }
                    if (!(area.type === 'private' && workspace.isRoot)) {
                        items.push({
                            id: workspace.id,
                            caption: (area.type === 'my' && workspace.isRoot) ? options.myRootCaption : workspace.title,
                            type: 'workspace',
                            areaId: area.id,
                            icon: 'suitcase',
                            myRootWorkspace: (area.type === 'my' && workspace.isRoot)
                        });
                    }
                });
            });
            return items;
        },

        decorateItem: function($li, item) {
            if (item.type === 'area') {
                $li.addClass('tb-workspaceListViewPage-area');
            }
        }
    });

});