﻿define(['underscore', 'jquery', 'srv', 'utils/ui', 'utils/uiManager', 'pubSub'], function(_, $, srv, ui, uiManager, pubSub) {

    return {
        onDelete: function(evt) {
            var that = this;
            evt && evt.preventDefault();
            var positioningClass = 'ui-popup-cardArea';
            ui.popup.list({
                items: [{
                    caption: 'Подтверждаю, удалить!',
                    classes: 'tb-confirmDelete',
                    confirmOperation: true
                }, {
                    caption: 'Отменить'
                }],
                classes: 'ui-popup-list ui-popup-list-largePadding ' + positioningClass,
                onSelected: function(value, item, $li, $root) {
                    if (item.confirmOperation) {
                        that.deleteEntity();
                    }
                }
            });
            // TODO question: do you agree
            //this.deleteEntity();
        },

        _modelToDelete: function() {
            return this.model;
        },

        _onDeleteSuccess: function() {
            if (uiManager.isTabletMode()) {
                pubSub.trigger('card:showDefault');
                this.router.tryForceUpdateCurrentView();
            } else {
                this.router.navigateBack();
            }

        },

        deleteEntity: function() {
            var that = this;
            var m = this._modelToDelete();
            var entityType = m.entityType;
            srv.del({
                entityType: entityType,
                entityId: m.id,
                success: function() {
                    srv.clearCache(entityType);
                    if (that.cachePatternsToClearOnDelete) {
                        _.each(that.cachePatternsToClearOnDelete, function(pattern) {
                            srv.clearCache(pattern);
                        });
                    }
                    that._onDeleteSuccess();
                }
            });
        }
    };


});