﻿define([
    'underscore',
    'jquery',
    'settings',
    'srv',
    'moment',
    'views/BasePageView',
    'text!views/dev/EventTestView.html'
], function (_, $, settings, srv, moment, BasePageView, contentTemplate) {

    function getAllEvents(element) {
        var result = [];
//        console.log(JSON.stringify(_.keys(element)));
        for (var key in element) {
            if (key.indexOf('on') === 0) {
                result.push(key.substring(2));
            }
        }
        return result.join(' ');
    }

    return BasePageView.extend({

        contentTemplate: contentTemplate,

        events: {
            'click .js-clear': 'onClear'
        },


        render: function () {
            BasePageView.prototype.render.apply(this, arguments);
            var $element = this.$('.js-touchMe');
            var $eventList = this.$('.js-events');
            //var allEvents = getAllEvents($element[0]);
            var allEvents = 'scroll seeking seeked show resize reset mousewheel mouseup mouseover mouseout mousemove mouseleave mouseenter mousedown keyup keypress keydown input focus ended drop dragstart dragover dragleave dragenter dragend drag dblclick contextmenu close click change abort wheel selectstart search paste cut copy beforepaste beforecut beforecopy touchstart MSPointerDown pointerdown MSGestureEnd touchmove MSPointerMove pointermove touchend MSPointerUp pointerup touchcancel MSPointerCancel pointercancel longTap doubleTap singleTap tap swipe swipeLeft swipeRight swipeUp swipeDown';
//            console.log(allEvents);
            //alert(allEvents);
            //alert($element.bind);
            $element.bind(allEvents, function(evt) {
                var timeString = moment().format('HH:mm:ss.SSS');
                var eventType = evt.type;
                var text = timeString + ' - ' + eventType;
                $('<div></div>').text(text).prependTo($eventList);
            });
        },

        onClear: function() {
            this.$('.js-events').empty();
        }

    });

});