﻿define([
    'underscore',
    'jquery',
    'settings',
    'srv',
    'views/BasePageView',
    'text!views/dev/TestView_content.html',
    'text!views/dev/TestView_header.html'
], function (_, $, settings, srv, BasePageView, contentTemplate, headerTemplate) {

    return BasePageView.extend({
        contentTemplate: contentTemplate,
        headerTemplate: headerTemplate,

        events: {
            'click .js-leftButton': 'onLeftButton',
            'click .js-rightButton': 'onRightButton',
            'click .js-showSimplePopup': 'onShowSimplePopup',
            'click .js-showErrorPopup': 'onShowErrorPopup',
            'click .js-showCalendarPopup': 'onShowCalendarPopup',
            'click .js-showHourPopup': 'onShowHourPopup',
            'click .js-showMinutePopup': 'onShowMinutePopup',
            'click .js-showSidebarPopup': 'onShowSidebarPopup',
            'click .js-showListPopup': 'onShowListPopup',
            'click .js-generateApiCallError': 'onGenerateApiCallError',
            'click .js-generateClientError': 'onGenerateClientError',
            'click .js-showRefreshIndicator': 'onShowRefreshIndicator'
        },

        onLeftButton: function(evt) {
            evt.preventDefault();
            alert('Left');
        },

        onRightButton: function(evt) {
            evt.preventDefault();
            alert('Right');
        },

        onShowSimplePopup: function(evt) {
            evt.preventDefault();
            this.ui.popup.message({
                headerText: 'Тестовый заголовок',
                text: 'Текст, текст, текст'
            });
        },

        onShowErrorPopup: function(evt) {
            evt.preventDefault();
            this.ui.popup.error({
                text: 'Дорогие друзья! Произошла ошибка. Необходимо отметить, что разработчик мобильного приложения решительно ничем не занят, он валяет дурака. Загрузите же его работой, нажав на кнопку "Загрузить" и отправив ему подробную информацию об ошибке.'
            });
        },

        onShowCalendarPopup: function(evt) {
            evt.preventDefault();
            this.ui.popup.calendar();
        },

        onShowSidebarPopup: function(evt) {
            evt.preventDefault();
            this.ui.popup.sidebar();
        },

        onShowRefreshIndicator: function(evt) {
            evt.preventDefault();
            this.ui.popup.refreshIndicator();
        },

        onShowListPopup: function(evt) {
            evt.preventDefault();
            this.ui.popup.list({
                items: ['Иван Иванович', 'Федосей Федосеевич', 'Карп Карпович'],
                onSelected: function(value) {
                    //console.log(JSON.stringify(arguments));
                    alert('Selected: ' + value);
                }
            });
        },

        onGenerateApiCallError: function() {
            srv.fetch({
                url: settings.restUrlBase + 'helloworld'
            });
        },

        onGenerateClientError: function() {
            undefined.someMethod();
        },

        render: function() {
            BasePageView.prototype.render.apply(this, arguments);
            this.ui.form.checkbox(this.$('.js-testCheckbox'));

            this.ui.form.select(this.$('.js-assignedTo'), {
                items: [
                    { value: '', caption: 'любой'},
                    { value: 'me', caption: 'Я'}
                ]
            });

            this.ui.form.select(this.$('.js-dueOn'), {
                items: [
                    { value: '', caption: 'любой'},
                    { value: 'me', caption: 'никакой'}
                ]
            });

            this.ui.form.select(this.$('.js-status'), {
                items: [
                    { value: '', caption: 'любой'},
                    { value: 'active', caption: 'активная'},
                    { value: 'completed', caption: 'завершена'}
                ]
            });

            this.ui.form.dateTimePicker(this.$('.js-dateTimePicker'), {
                /*onSelected: function(selectedDateTime) {

                }*/
            });
        },

        onShowHourPopup: function() {
            this.ui.popup.hourSelector();
        },

        onShowMinutePopup: function() {
            this.ui.popup.minuteSelector({
                hour: 12
            });
        }

    });

});