﻿define([
    'underscore',
    'jquery'
], function (
    _,
    $
    ) {

    return {

        locationContextCaption: function() {
            var structureSection = this.structureSectionByLocationContext();
            if (structureSection) {
                if (structureSection.workspace.title) {
                    return structureSection.area.title + ' > ' + structureSection.workspace.title;
                } else {
                    return structureSection.area.title;
                }
            } else {
                return 'Все порталы, все проекты';
            }
        },

        structureSectionByLocationContext: function() {
            var locationContext = this.locationContext();
            var structure = this.refData.structure;
            var area = _.findWhere(structure.areas, {id: locationContext.areaId});
            if (!area) {
                return undefined;
            }

            // TODO remove this hack
            // HACK: to support weird structure tree
            /*if (area.type === "private") {
                return {
                    area: area,
                    workspace: {
                        id: area.rootWorkspaceID,
                        title: area.title,
                        tools: area.tools
                    }
                };
            }*/

            var workspace = _.findWhere(area.workspaces, {id: locationContext.workspaceId});
            if (!workspace) {
                return undefined;
            }
            return {
                area: area,
                workspace: workspace
            };
        },


        locationContext: function() {
            var context = {};
            this.options.areaId && (context.areaId = this.options.areaId);
            this.options.workspaceId && (context.workspaceId = this.options.workspaceId);
            return context;
        }
    };

});