﻿/**
 * @class LoginView
 */
define([
    'underscore',
    'jquery',
    'views/BaseView',
    'text!views/login/LoginView.html',
    'settings',
    'pubSub',
    'authentication'
], function (_, $, BaseView, template, settings, pubSub, authentication) {
    return BaseView.extend({

        className: 'ui-page',

        template: template,

        events: {
            'click .js-login': 'onLogin',
            'click .js-register': 'onRegister',
            'click .js-changePassword': 'onChangePassword'
        },

        noSidebar: true,

        initialize: function (options) {
            var that = this;
            BaseView.prototype.initialize.apply(this, arguments);
            this.listenTo(pubSub, 'login:fail', function(args) {
                var message = args.errorDescription || that.i18n.login.loginFailedReasons[args.reason];
                that.$('.js-spinner').hide();
                that.$('.js-loginFailed').text(message).show();
            });
        },

        render: function() {
            this.$el.addClass('tb-loginPage');
            BaseView.prototype.render.apply(this, arguments);
            //this.$('.js-loginScreen').css('min-height', $(window).height());
            this.$('.js-spinner').hide();
        },

        onLogin: function(evt) {
            this.$('.js-loginFailed').hide();
            var login = this.$('.js-email').val();
            var password = this.$('.js-password').val();
            this.$('.js-spinner').show();
            authentication.login(login, password);
            evt.preventDefault();
        },

        onBackButton: function() {
            // exit app if we run under Cordova
            navigator && navigator.app && navigator.app.exitApp && navigator.app.exitApp();
        },

        onRegister: function(evt) {
            evt && evt.preventDefault();
            window.open('https://app.teambridge.ru/#!/register', '_system');
        },

        onChangePassword: function(evt) {
            evt && evt.preventDefault();
            window.open('https://app.teambridge.ru/#!/changePassword', '_system');
        }

    });
});