﻿define([
    'underscore',
    'jquery',
    'views/BasePageView',
    'text!views/maintenance/FeedbackView_content.html',
    'text!views/maintenance/FeedbackView_header.html'
], function (
    _,
    $,
    BasePageView,
    contentTemplate,
    headerTemplate
    ) {

    return BasePageView.extend({
        contentTemplate: contentTemplate,
        headerTemplate: headerTemplate,

        events: {
            'click .js-back': 'onBack',
            'click .js-send': 'onSend'
        },

        initialize: function(options) {
            BasePageView.prototype.initialize.apply(this, arguments);

        },

        render: function() {
            var that = this;
            this.$el.addClass('tb-feedback');
            BasePageView.prototype.render.apply(this, arguments);
            setTimeout(function() {
                that.$('textarea').height($(window).height()/2 - that.$('.js-header').height());
                //document.body.scrollTop = 0;
            }, 200);
        },

        onSend: function(evt) {
            var that = this;
            evt.preventDefault();
            this.$('.js-send').addClass('ui-disabled');
            setTimeout(function() {
                that.log.sync({
                    userMessage: that.$('textarea').val(),
                    success: function() {
                        that.$('.js-send').removeClass('ui-disabled');
                        that.router.navigateBack();
                        setTimeout(function() {
                            that.ui.popup.message({
                                text: 'Информация успешно отправлена в TeamBridge. Спасибо за использование нашего сервиса!'
                            });
                        }, 200);
                    },
                    error: function() {
                        that.$('.js-send').removeClass('ui-disabled');
                    }
                });
            }, 1);


        }


    });

});