﻿/**
 * @class SidebarView
 */
define([
    'underscore',
    'jquery',
    'views/BaseView',
    'text!views/sidebar/SidebarView_data.html',
    'settings',
    'views/refDataSupport',
    'utils/toolUtil',
    'utils/navigationUtil',
    'utils/cache/structureCache',
	'utils/scrollStack'
], function (_, $, BaseView, dataTemplate, settings, refDataSupport, toolUtil, navigationUtil, structureCache, scrollStack)
{

    return BaseView.extend({

        toolUtil: toolUtil,

        available: false,

        events: {
        	'click .js-new': 'onNew',
        },

        initialize: function (options) {
            this.include(refDataSupport);
            BaseView.prototype.initialize.apply(this, arguments);
        	//this._subscribeToEvents();
        },

        /*_subscribeToEvents: function() {
            var that = this;
            this.listenTo(this.pubSub, 'sidebar:show', function() {
                that.show();
            });
            this.listenTo(this.pubSub, 'sidebar:hide', function() {
                that.hide();
            });
        },*/

        refData: {
            structure: structureCache.refDataLoader
        },

        updateData: function() {
            this._mainDataLoaded = true;
            this.onDataUpdated();
        },

        renderData: function() {
            var that = this;
            this.$el.html(dataTemplate.call(this));
            this.ui.createLinks(this.$el, this.router, {
            	onClick: function ()
            	{
            		scrollStack.clear();
                    that.ui.popup.closeAll();
                }
            });
            this._tuneAppearance();
            this.available = true;
        },

        _tuneAppearance: function() {
            this.$('.tb-sidebarList-header').prev().css('border-bottom', 'none');
            this.$('.tb-sidebarList li').last().css('border-bottom', 'none');
        },

        setUnavailable: function() {
            this.available = false;
        },

        /*show: function() {
            // TODO do it via ui.popup (we need to create obstacle etc.)
            this.$el.show();
        },

        hide: function() {
            // TODO do it via ui.popup (we need to remove obstacle etc.)
            this.$el.hide();
        },*/

        onNew: function (e)
        {
            this.ui.popup.closeAll();
            navigationUtil.showEntityCreationMenu(this.router);
        },
    });
});