﻿/**
 * @class TaskFiltersPopupView
 */
define([
    'underscore',
    'jquery',
    'views/common/BaseFilterPopupView',
    'text!views/tasks/TaskFiltersPopupView.html',
    'models/tasks/TaskFilterModel'
], function(
    _,
    $,
    BaseFilterPopupView,
    template,
    TaskFilterModel
    ) {

    return BaseFilterPopupView.extend({

        template: template,

        filterStorageKey: '__TaskFilter',

        filterModelClass: TaskFilterModel,

        initialize: function(options) {
            BaseFilterPopupView.prototype.initialize.apply(this, arguments);
        },

        /*createModel: function() {
            return new TaskFilterModel();
        },*/

        _renderFilters: function() {
            var that = this;
            this.ui.form.select(this.$('.js-dueDate'), {
                items: [
                    { value: '', caption: 'любой срок'},
                    { value: 'overdue', caption: 'просроченные'},
                    { value: 'notSpecified', caption: 'срок не указан'},
                    { value: 'today', caption: 'сегодня'},
                    { value: 'tomorrow', caption: 'завтра'},
                    { value: 'currentWeek', caption: 'на этой неделе'},
                    { value: 'nextWeek', caption: 'на следующей неделе'},
                    { value: 'upcoming', caption: 'предстоящие'}
                ],
                emptyCaption: 'любой срок',
                listClasses: 'ui-popup-list tb-dueDate-list',
                onSelected: function() {
                    //that.update();
                }
            });
            var assignedToItems = [
                { value: '', caption: 'любой ответственный'},
                { value: 'me', caption: 'назначенные мне'},
                { value: 'unassigned', caption: 'неназначенные'},
                { value: 'createdByMe', caption: 'созданные мной'}
            ];
            _.each(this.options.parentView.refData.allUsers, function(user) {
                if (user && user.id !== that.options.parentView.refData.currentUser.id) {
                    assignedToItems.push({
                        value: user.id,
                        caption: user.name
                    });
                }
            });

            this.ui.form.select(this.$('.js-assignedTo'), {
                items: assignedToItems,
                emptyCaption: 'любой ответственный',
                onSelected: function() {
                    //that.update();
                }
            });

            this.ui.form.select(this.$('.js-status'), {
                items: [
                    { value: '', caption: 'любой статус'},
                    { value: 'active', caption: 'активная'},
                    { value: 'completed', caption: 'завершена'}
                ],
                emptyCaption: 'любой статус',
                onSelected: function() {
                    //that.update();
                }
            });

            /*this.$('.js-dueDate').trigger('ui:refresh');
            this.$('.js-assignedTo').trigger('ui:refresh');
            this.$('.js-status').trigger('ui:refresh');*/
        }

    });

});