﻿/**
 * @class TaskSortPopupView
 */
define([
    'underscore',
    'jquery',
    'views/common/BaseSortPopupView',
    'text!views/tasks/TaskSortPopupView.html',
    'models/tasks/TaskSortModel'
], function(
    _,
    $,
    BaseSortPopupView,
    template,
    TaskSortModel
    ) {

    return BaseSortPopupView.extend({

        template: template,

        sortStorageKey: '__TaskSort',

        sortModelClass: TaskSortModel,

        events: _.extend({
            'click .js-sortParameter': 'onSortParameterClicked',
            'click .js-sortDirection': 'onSortDirectionClicked'
        }, BaseSortPopupView.prototype.events),

        initialize: function(options) {
            BaseSortPopupView.prototype.initialize.apply(this, arguments);
        },

        _renderSortParameters: function() {
            var sortBy = this.model.get('sortBy');
            this.$('[data-sort-by="' + sortBy + '"]').addClass('ui-selected');
            var sortDirection = this.model.get('sortDirection');
            this.$('[data-sort-direction="' + sortDirection + '"]').addClass('ui-selected');
        },

        onSortParameterClicked: function(evt) {
            evt && evt.preventDefault();
            this.$('.js-sortParameter').removeClass('ui-selected');
            var sortBy = $(evt.currentTarget).addClass('ui-selected').attr('data-sort-by');
            this.model.set('sortBy', sortBy);
        },

        onSortDirectionClicked: function(evt) {
            evt && evt.preventDefault();
            this.$('.js-sortDirection').removeClass('ui-selected');
            var sortDirection = $(evt.currentTarget).addClass('ui-selected').attr('data-sort-direction');
            this.model.set('sortDirection', sortDirection);
        }

    });

});